#pragma once

#include "CoreMinimal.h"
#include "ItemAddon.h"
#include "Templates/SubclassOf.h"
#include "WeddingRing.generated.h"

class UStatusEffect;
class ASurvivor;

UCLASS(Blueprintable, meta=(BlueprintSpawnableComponent))
class DBDSURVIVORCOLLECTABLES_API UWeddingRing : public UItemAddon
{
	GENERATED_BODY()

private:
	UPROPERTY(EditAnywhere, BlueprintReadWrite, meta=(AllowPrivateAccess=true))
	TSubclassOf<UStatusEffect> _increaseObsessionChanceStatusEffect;

	UPROPERTY(EditAnywhere, BlueprintReadWrite, meta=(AllowPrivateAccess=true))
	TSubclassOf<UStatusEffect> _revealSelfToObsessionStatusEffectClass;

	UPROPERTY(EditInstanceOnly, BlueprintReadWrite, Transient, Instanced, meta=(AllowPrivateAccess=true))
	UStatusEffect* _revealSelfToObsessionStatusEffect;

private:
	UFUNCTION(BlueprintCallable)
	void Authority_OnObsessionChanged(ASurvivor* newObsession, ASurvivor* previousObsession);

public:
	UWeddingRing();
};

FORCEINLINE uint32 GetTypeHash(const UWeddingRing) { return 0; }
